!     $Id: libgrf.f90,v 1.6 2012/11/09 13:12:30 fukuyama Exp $

MODULE libgrf

  USE grftype,ONLY: grf_attr_type
  USE grfutils,ONLY: grfut1,grfut2,grfut3,grfut4,setrgba
  USE grf1d_mod,ONLY: grf1d
  USE grd1d_mod,ONLY: grd1d
  USE grf2d_mod,ONLY: grf2d
  USE grd2d_mod,ONLY: grd2d

CONTAINS

  SUBROUTINE GRF2DA(NGP,GX,GY,GZ,NXM,NXMAX,NYMAX,STR,MODE_LS,IPRD)
    IMPLICIT NONE
    INTEGER,INTENT(IN):: NGP,NXM,NXMAX,NYMAX,MODE_LS,IPRD
    REAL(4),INTENT(IN):: GX(NXMAX),GY(NYMAX),GZ(NXM,NYMAX)
    CHARACTER(LEN=*),INTENT(IN):: STR

    CALL GRF2D(NGP,GX,GY,GZ,NXM,NXMAX,NYMAX,STR,MODE_LS,IPRD,1)
    RETURN
  END SUBROUTINE GRF2DA

  SUBROUTINE GRF2DAX(GP, &
                     GXMIN,GXMAX,GXSTEP,GXORG, &
                     GYMIN,GYMAX,GYSTEP,GYORG, &
                     GFMIN,GFMAX,GFSTEP,GFORG, &
                     GX,GY,GZ,NXM,NXMAX,NYMAX,STR,MODE_LS,IPRD)
    IMPLICIT NONE
    INTEGER,INTENT(IN):: NXM,NXMAX,NYMAX,MODE_LS,IPRD
    REAL(4),INTENT(IN):: GP(4),GX(NXMAX),GY(NYMAX),GZ(NXM,NYMAX)
    REAL(4),INTENT(IN):: GXMIN,GXMAX,GXSTEP,GXORG
    REAL(4),INTENT(IN):: GYMIN,GYMAX,GYSTEP,GYORG
    REAL(4),INTENT(IN):: GFMIN,GFMAX,GFSTEP,GFORG
    CHARACTER(LEN=*),INTENT(IN):: STR
    REAL(4),DIMENSION(:),ALLOCATABLE:: LINE_VALUE
    INTEGER:: N,N1,N2,NMAX,NGP

    NGP=0
    N1=ABS(GFMAX-GFORG)/GFSTEP+1
    N2=ABS(GFMIN-GFORG)/GFSTEP+1
    NMAX=N1+1+N2
    ALLOCATE(LINE_VALUE(NMAX))
    DO N=1,N1
       LINE_VALUE(N2+1+N)=GFORG+GFSTEP*N
    ENDDO
    LINE_VALUE(N2+1)=GFORG
    DO N=1,N2
       LINE_VALUE(N2+1-N)=GFORG-GFSTEP*N
    ENDDO

    CALL GRF2D(NGP,GX,GY,GZ,NXM,NXMAX,NYMAX,STR,MODE_LS,IPRD,1, &
               GPXMIN=GP(1),GPXMAX=GP(2),GPYMIN=GP(3),GPYMAX=GP(4), &
               XMIN=GXMIN,XMAX=GXMAX,XORG=GXORG,XSCALE_STEP=GXSTEP, &
               YMIN=GYMIN,YMAX=GYMAX,YORG=GYORG,YSCALE_STEP=GYSTEP, &
               FMIN=GFMIN,FMAX=GFMAX,FORG=GFORG, &
               LINE_VALUE=LINE_VALUE,NLMAX=NMAX)

    DEALLOCATE(LINE_VALUE)
    RETURN
  END SUBROUTINE GRF2DAX

  SUBROUTINE GRF2DB(NGP,GX,GY,GZ,NXM,NXMAX,NYMAX,STR)
    IMPLICIT NONE
    INTEGER,INTENT(IN):: NGP,NXM,NXMAX,NYMAX
    REAL(4),INTENT(IN):: GX(NXMAX),GY(NYMAX),GZ(NXM,NYMAX)
    CHARACTER(LEN=*),INTENT(IN):: STR

    CALL GRF2D(NGP,GX,GY,GZ,NXM,NXMAX,NYMAX,STR,4)
    RETURN
  END SUBROUTINE GRF2DB

  SUBROUTINE GRF2DBX(GP, &
                     GXMIN,GXMAX,GXSTEP,GXORG, &
                     GYMIN,GYMAX,GYSTEP,GYORG, &
                     GFMIN,GFMAX,GFSTEP,GFORG, &
                     GX,GY,GZ,NXM,NXMAX,NYMAX,STR,GP3D)
    IMPLICIT NONE
    INTEGER,INTENT(IN):: NXM,NXMAX,NYMAX
    REAL(4),INTENT(IN):: GP(4),GX(NXMAX),GY(NYMAX),GZ(NXM,NYMAX),GP3D(6)
!    REAL(4),INTENT(IN):: GP(6),GX(NXMAX),GY(NYMAX),GZ(NXM,NYMAX),GP3D(6)
    REAL(4),INTENT(IN):: GXMIN,GXMAX,GXSTEP,GXORG
    REAL(4),INTENT(IN):: GYMIN,GYMAX,GYSTEP,GYORG
    REAL(4),INTENT(IN):: GFMIN,GFMAX,GFSTEP,GFORG
    CHARACTER(LEN=*),INTENT(IN):: STR
    REAL(4),DIMENSION(:),ALLOCATABLE:: LINE_VALUE
    INTEGER:: N,N1,N2,NMAX,NGP

    NGP=0
    N1=ABS(GFMAX-GFORG)/GFSTEP+1
    N2=ABS(GFMIN-GFORG)/GFSTEP+1
    NMAX=N1+1+N2
    ALLOCATE(LINE_VALUE(NMAX))
    DO N=1,N1
       LINE_VALUE(N2+1+N)=GFORG+GFSTEP*N
    ENDDO
    LINE_VALUE(N2+1)=GFORG
    DO N=1,N2
       LINE_VALUE(N2+1-N)=GFORG-GFSTEP*N
    ENDDO

    CALL GRF2D(NGP,GX,GY,GZ,NXM,NXMAX,NYMAX,STR,MODE_2D=4, &
               GPXMIN=GP(1),GPXMAX=GP(2),GPYMIN=GP(3),GPYMAX=GP(4), &
               XMIN=GXMIN,XMAX=GXMAX,XORG=GXORG,XSCALE_STEP=GXSTEP, &
               YMIN=GYMIN,YMAX=GYMAX,YORG=GYORG,YSCALE_STEP=GYSTEP, &
               FMIN=GFMIN,FMAX=GFMAX,FORG=GFORG, &
               LINE_VALUE=LINE_VALUE,NLMAX=NMAX, &
               PAINT_VALUE=LINE_VALUE,NPMAX=NMAX, &
               BEV_XLEN=GP3D(1),BEV_YLEN=GP3D(2),BEV_ZLEN=GP3D(3), &
               BEV_PHI=GP3D(4),BEV_CHI=GP3D(5),BEV_DISTANCE=GP3D(6))

    DEALLOCATE(LINE_VALUE)
    RETURN
  END SUBROUTINE GRF2DBX

  SUBROUTINE GRF2DC(NGP,GX,GY,GZ,NXM,NXMAX,NYMAX,STR,MODE_LS,IPRD)
    IMPLICIT NONE
    INTEGER,INTENT(IN):: NGP,NXM,NXMAX,NYMAX,MODE_LS,IPRD
    REAL(4),INTENT(IN):: GX(NXMAX),GY(NYMAX),GZ(NXM,NYMAX)
    CHARACTER(LEN=*),INTENT(IN):: STR

    CALL GRF2D(NGP,GX,GY,GZ,NXM,NXMAX,NYMAX,STR,MODE_LS,IPRD,2)
    RETURN
  END SUBROUTINE GRF2DC

  SUBROUTINE GRF2DCX(GP, &
                     GXMIN,GXMAX,GXSTEP,GXORG, &
                     GYMIN,GYMAX,GYSTEP,GYORG, &
                     GFMIN,GFMAX,GFSTEP,GFORG, &
                     GX,GY,GZ,NXM,NXMAX,NYMAX,STR,MODE_LS,IPRD)
    IMPLICIT NONE
    INTEGER,INTENT(IN):: NXM,NXMAX,NYMAX,MODE_LS,IPRD
    REAL(4),INTENT(IN):: GP(4),GX(NXMAX),GY(NYMAX),GZ(NXM,NYMAX)
    REAL(4),INTENT(IN):: GXMIN,GXMAX,GXSTEP,GXORG
    REAL(4),INTENT(IN):: GYMIN,GYMAX,GYSTEP,GYORG
    REAL(4),INTENT(IN):: GFMIN,GFMAX,GFSTEP,GFORG
    CHARACTER(LEN=*),INTENT(IN):: STR
    REAL(4),DIMENSION(:),ALLOCATABLE:: PAINT_VALUE
    INTEGER:: N,N1,N2,NMAX,NGP

    NGP=0
    N1=ABS(GFMAX-GFORG)/GFSTEP+1
    N2=ABS(GFMIN-GFORG)/GFSTEP+1
    NMAX=N1+1+N2
    ALLOCATE(PAINT_VALUE(NMAX))
    DO N=1,N1
       PAINT_VALUE(N2+1+N)=GFORG+GFSTEP*N
    ENDDO
    PAINT_VALUE(N2+1)=GFORG
    DO N=1,N2
       PAINT_VALUE(N2+1-N)=GFORG-GFSTEP*N
    ENDDO

    CALL GRF2D(NGP,GX,GY,GZ,NXM,NXMAX,NYMAX,STR,MODE_LS,IPRD,2, &
               GPXMIN=GP(1),GPXMAX=GP(2),GPYMIN=GP(3),GPYMAX=GP(4), &
               XMIN=GXMIN,XMAX=GXMAX,XORG=GXORG,XSCALE_STEP=GXSTEP, &
               YMIN=GYMIN,YMAX=GYMAX,YORG=GYORG,YSCALE_STEP=GYSTEP, &
               FMIN=GFMIN,FMAX=GFMAX,FORG=GFORG, &
               PAINT_VALUE=PAINT_VALUE,NPMAX=NMAX)

    DEALLOCATE(PAINT_VALUE)
    RETURN
  END SUBROUTINE GRF2DCX

END MODULE libgrf
