MODULE COMM
!=========================================================================
!    
!  * DECLARE VARIABLES
!  * SUBROUTINE ALLOCATE
!  * SUBROUTINE DEALLOCATE
!=========================================================================

  IMPLICIT NONE

!  ***** PARAMETERS *****
  REAL(8),SAVE :: RR,RA,RKAP,RDLT,BB

  REAL(8),SAVE :: T0,TA

!  ***** PROFILE PARAMETERS *****
  REAL(8),DIMENSION(:),ALLOCATABLE,SAVE :: XX,XXP,PXa,RG, DR, RHV
  REAL(8),DIMENSION(:,:,:),ALLOCATABLE,SAVE :: DFa, VCa, CEa
  REAL(8),DIMENSION(:,:),ALLOCATABLE,SAVE :: DB

  REAL(8),DIMENSION(:,:),ALLOCATABLE,SAVE :: LHBMTX

  REAL(8),DIMENSION(:,:),ALLOCATABLE,SAVE :: TMPG,PWG,DFG,VCG,CEG
  REAL(8),DIMENSION(:),ALLOCATABLE,SAVE :: TMP0, TMPa

  REAL(8),DIMENSION(:,:),ALLOCATABLE,SAVE :: TMP_EV

  REAL(8),SAVE :: PW0, PWA, D0, D1, LTCR, DBF


!  ***** CONTROL PARAMETERS *****
  REAL(8),DIMENSION(:),ALLOCATABLE,SAVE :: DELXX_IT,DELXX_IT_LOG,NITG
  REAL(8),DIMENSION(:,:),ALLOCATABLE,SAVE :: DELXXG, DELXXG_LOG
  REAL(8),SAVE :: DT,EPSIT

  INTEGER(4),SAVE :: NRMAX, NSMAX, NTMAX, NITMAX, COUNT
  INTEGER(4),SAVE :: MDLM, MDLD, MDLP, MDLDB


  REAL(8),SAVE :: CPUTIME
  CHARACTER(80),SAVE :: LINE
  INTEGER(4),SAVE :: KL1,INPUTEND


  CONTAINS

    SUBROUTINE ALLOC_TRE
      INTEGER(4) :: IERR

      ALLOCATE( XX(1:(NRMAX+1)*NSMAX),XXP(1:(NRMAX+1)*NSMAX),  STAT=IERR)
        IF(IERR /= 0) GOTO 900
      ALLOCATE( RG(1:NRMAX+1), STAT=IERR)
        IF(IERR /= 0) GOTO 900
      ALLOCATE( DR(1:NRMAX), STAT=IERR)
        IF(IERR /= 0) GOTO 900
      ALLOCATE( TMP_EV(1:NTMAX,NSMAX), STAT=IERR)
        IF(IERR /= 0) GOTO 900
      ALLOCATE( TMP0(1:NSMAX), TMPa(1:NSMAX), STAT=IERR)
        IF(IERR /= 0) GOTO 900
      ALLOCATE( DELXX_IT(1:NITMAX),DELXX_IT_LOG(1:NITMAX), NITG(1:NITMAX), STAT=IERR)
        IF(IERR /= 0) GOTO 900

      ALLOCATE( DFa(1:NSMAX,1:NSMAX,1:NRMAX+1), &
                VCa(1:NSMAX,1:NSMAX,1:NRMAX+1), &
                CEa(1:NSMAX,1:NSMAX,1:NRMAX+1), STAT=IERR)
        IF(IERR /= 0) GOTO 900
      ALLOCATE( PXa(1:NSMAX*(NRMAX+1)), STAT=IERR)
        IF(IERR /= 0) GOTO 900

      ALLOCATE( DB(1:NRMAX+1,1:NSMAX), STAT=IERR)
        IF(IERR /= 0) GOTO 900

      ALLOCATE( LHBMTX(4*NSMAX-1,NSMAX*(NRMAX+1)),  &
                RHV(1:NSMAX*(NRMAX+1)), STAT=IERR)
        IF(IERR /= 0) GOTO 900

      ALLOCATE( TMPG(1:NRMAX+1,NSMAX), &
                 PWG(1:NRMAX+1,NSMAX), &
                 DFG(1:NRMAX+1,NSMAX), &
                 VCG(1:NRMAX+1,NSMAX), &
                 CEG(1:NRMAX+1,NSMAX), &
                 DELXXG(1:NRMAX+1,NSMAX), &
                 DELXXG_LOG(1:NRMAX,NSMAX), STAT=IERR)
        IF(IERR /= 0) GOTO 900

900 CONTINUE
       IF(IERR /= 0) WRITE(6,*) 'ALLOCATION ERROR : IERR = ', IERR

       RETURN
    END SUBROUTINE ALLOC_TRE

    
    SUBROUTINE DEALLOC_TRE

      DEALLOCATE(XX,XXP)
      DEALLOCATE(RG)
      DEALLOCATE(DR)
      DEALLOCATE(TMP_EV)
      DEALLOCATE(TMP0,TMPa)
      DEALLOCATE(DELXX_IT,DELXX_IT_LOG,NITG)
      DEALLOCATE(DFa,VCa,CEa)
      DEALLOCATE(PXa)
      DEALLOCATE(DB)
      DEALLOCATE(LHBMTX,RHV)
      DEALLOCATE(TMPG,PWG,DFG,VCG,CEG,DELXXG,DELXXG_LOG)

    END SUBROUTINE DEALLOC_TRE

END MODULE COMM
