SUBROUTINE EXEC
!=====================================================================
!
!               ***  MAIN ROUITNE OF TRE ***
!         Time-stamp: < 2011/11/10 17:51  T.IKARI >
!
!=====================================================================
  USE COMM
  USE CALC_COEF
  IMPLICIT NONE

  !=== INTERNAL VARIABLES ===
  REAL(8),DIMENSION(1:NSMAX*(NRMAX+1)) :: XXC
  REAL(8),DIMENSION(1:NSMAX*(NRMAX+1)) :: DELXX

  REAL(8) :: T1, T2
  INTEGER(4) :: NR,NT,NM,NIT,NS,NSR,NSC,BANDIERR

  !=== INITIALIZATION OF PROFILE ===
  !=== TEMPERTURE :
  DO NS = 1, NSMAX
     XX(NS) = T0
     DO NR = 2, NRMAX+1
        XX(NS+(NR-1)*NSMAX) = T0-(T0-TA)*(RG(NR)/RA)**2
     END DO
  END DO

  CALL CPU_TIME(T1)

  COUNT    = 0
  DELXX_IT = EPSIT
  DELXX    = EPSIT
  
  DO NT = 1, NTMAX ! main loop
     XXP(1:NSMAX*(NRMAX+1)) = XX(1:NSMAX*(NRMAX+1))

     DO NIT = 1, NITMAX
        XXC(1:NSMAX*(NRMAX+1)) = XX(1:NSMAX*(NRMAX+1))

        DFG = 0.D0 ; DFa = 0.D0
        VCG = 0.D0 ; VCa = 0.D0
        CEG = 0.D0 ; CEa = 0.D0
        PWG = 0.D0 ; PXa = 0.D0
 
        CALL CALC_DFA
        CALL CALC_VCA
        CALL CALC_CEA
        CALL CALC_PXA

        CALL PRV_MTHD

        CALL BLD_MTRX

!        OPEN(40,FILE='test2.txt')
!        DO NS = 1, NRMAX+1
!           WRITE(40,'(3ES10.3)') (LHBMTX(NR,NS), NR=1,3)
!        END DO
!        CLOSE(40)

        CALL BANDRD( LHBMTX, RHV, NSMAX*(NRMAX+1), 4*NSMAX-1, 4*NSMAX-1, BANDIERR )
        XX(1:NSMAX*(NRMAX+1)) = RHV(1:NSMAX*(NRMAX+1))

        !--- CONVERGENCE CHECK ---
        DO NM = 1, NSMAX*(NRMAX+1)
           DELXX(NM) = ABS( (XX(NM)-XXC(NM)) / XX(NM) )
        END DO
        IF(NT==NTMAX) DELXX_IT(NIT) = MAXVAL(DELXX)
        
        IF(MAXVAL(DELXX) < EPSIT) THEN
           DELXX_IT(NIT) = EPSIT
           COUNT = MAX(COUNT,NIT)
           GOTO 700
        END IF
     END DO

  ! --- OVERFLOW IN ITERATION
  COUNT = NITMAX+1
700 CONTINUE

  END DO

  CALL CPU_TIME(T2)
  CPUTIME = T2 - T1

  ! --- for graphic output
  DO NS = 1, NSMAX
     DO NR = 1, NRMAX+1
        TMPG(NR,NS)   = XX(NS+(NR-1)*NSMAX)
     END DO
  END DO
  DO NIT = 1, NITMAX
     NITG(NIT) = DBLE(NIT)
     DELXX_IT_LOG(NIT) = LOG10(DELXX_IT(NIT))
  END DO

601 FORMAT(A8,I8,6X,A8,I8)
602 FORMAT(A8,1PE12.4,2X,A8,1PE12.4)

!  DO NIT = 1, NITMAX
!     WRITE(*,*) DELXX_IT(NIT)
!  END DO

  WRITE(6,*) ' ---------- THE NUMBER OF ITERATION --------- '
  WRITE(6,601) 'NTMAX = ',NTMAX,  'NITMAX=',NITMAX
  WRITE(6,601) 'CNT_F = ',COUNT,  'CNT_F =',COUNT
  WRITE(6,602) 'TIME_F= ',CPUTIME,'TIME_F=',CPUTIME
  WRITE(6,*) ' '

END SUBROUTINE EXEC
